#ifndef _KGR_PATCH_BSC1039496_H
#define _KGR_PATCH_BSC1039496_H

#if defined(CONFIG_X86_64)

int kgr_patch_bsc1039496_init(void);
int kgr_restart_khugepaged(void);

int kgr_copy_strings_kernel(int argc, const char *const *__argv,
	struct linux_binprm *bprm);
asmlinkage long kgr_sys_execve(const char __user *filename,
	const char __user *const __user *argv,
	const char __user *const __user *envp);
int kgr_do_execve(struct filename *filename,
	const char __user *const __user *__argv,
	const char __user *const __user *__envp);
int kgr_do_execveat(int fd, struct filename *filename,
	const char __user *const __user *__argv,
	const char __user *const __user *__envp,
	int flags);
asmlinkage long kgr_sys_execveat(int fd, const char __user *filename,
	const char __user *const __user *argv,
	const char __user *const __user *envp,
	int flags);
asmlinkage long kgr_compat_sys_execve(const char __user *filename,
	const compat_uptr_t __user *argv,
	const compat_uptr_t __user *envp);
asmlinkage long kgr_compat_sys_execveat(int fd, const char __user *filename,
	const compat_uptr_t __user *argv, const compat_uptr_t __user *envp,
	int flags);
int kgr_remove_arg_zero(struct linux_binprm *bprm);
void kgr_show_map_vma(struct seq_file *m, struct vm_area_struct *vma, int is_pid);
long kgr__get_user_pages(struct task_struct *tsk, struct mm_struct *mm,
	unsigned long start, unsigned long nr_pages, unsigned int gup_flags,
	struct page **pages, struct vm_area_struct **vmas, int *nonblocking);
int kgr_handle_pte_fault(struct mm_struct *mm, struct vm_area_struct *vma,
	unsigned long address, pte_t *pte, pmd_t *pmd, unsigned int flags);
int kgr_expand_downwards(struct vm_area_struct *vma, unsigned long address);
int kgr_expand_stack(struct vm_area_struct *vma, unsigned long address);
int kgr_do_huge_pmd_anonymous_page(struct mm_struct *mm,
	struct vm_area_struct *vma, unsigned long address, pmd_t *pmd,
	unsigned int flags);
int kgr_khugepaged(void *none);
struct mm_struct *kgr_mm_init(struct mm_struct *mm, struct task_struct *p);

#define KGR_PATCH_BSC1039496_FUNCS \
	KGR_PATCH(copy_strings_kernel, kgr_copy_strings_kernel), \
	KGR_PATCH(SyS_execve, kgr_sys_execve), \
	KGR_PATCH(do_execve, kgr_do_execve), \
	KGR_PATCH(do_execveat, kgr_do_execveat), \
	KGR_PATCH(SyS_execveat, kgr_sys_execveat), \
	KGR_PATCH(compat_SyS_execve, kgr_compat_sys_execve), \
	KGR_PATCH(compat_SyS_execveat, kgr_compat_sys_execveat), \
	KGR_PATCH(remove_arg_zero, kgr_remove_arg_zero), \
	KGR_PATCH(show_map_vma, kgr_show_map_vma), \
	KGR_PATCH(__get_user_pages, kgr__get_user_pages), \
	KGR_PATCH(handle_pte_fault, kgr_handle_pte_fault), \
	KGR_PATCH(expand_downwards, kgr_expand_downwards), \
	KGR_PATCH(expand_stack, kgr_expand_stack), \
	KGR_PATCH(do_huge_pmd_anonymous_page, kgr_do_huge_pmd_anonymous_page), \
	KGR_PATCH(khugepaged, kgr_khugepaged), \
	KGR_PATCH(mm_init, kgr_mm_init),

#else /* CONFIG_X86_64 */

static inline int kgr_patch_bsc1039496_init(void) { return 0; }
static inline int kgr_restart_khugepaged(void) { return 0; }
#define KGR_PATCH_BSC1039496_FUNCS

#endif /* CONFIG_X86_64 */

static inline void kgr_patch_bsc1039496_cleanup(void) {}

#endif
